#
# spec file for package syzkaller
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define version_unconverted 0.0+git.20160615
Name:           syzkaller
Version:        0.0+git.20160615
Release:        3.2
Summary:        Distributed, unsupervised, coverage-guided Linux syscall fuzzer
License:        Apache-2.0
Group:          Development/Tools/Other
Url:            https://github.com/google/syzkaller
Source0:        %{name}-%{version}.tar.xz
BuildRequires:  gcc-c++
BuildRequires:  go
BuildRequires:  make
BuildRequires:  xz
# for -fsanitize-coverage
Recommends:     gcc6
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExclusiveArch:  x86_64 aarch64 ppc64le

%description
syzkaller is a distributed, unsupervised, coverage-guided Linux syscall fuzzer.
It is meant to be used with KASAN (CONFIG_KASAN=y), KTSAN (CONFIG_KTSAN=y), or
KUBSAN.

%prep
%setup -q

mkdir -p go/src/github.com/google/
ln -s "$PWD" go/src/github.com/google/syzkaller

%build
# bug in makefile
mkdir bin

export GOPATH="$GOPATH:$PWD/go"
make %{?_smp_mflags} CFLAGS="%{optflags}" NOSTATIC=1 all all-tools

%install
install -d %{buildroot}/%{_bindir}
install -m 0755 bin/* %{buildroot}/%{_bindir}

%files
%defattr(-,root,root)
%doc AUTHORS CONTRIBUTORS LICENSE README.md syz-manager/example.cfg structure.png sys/sys.txt tools/create-image.sh
%{_bindir}/syz-execprog
%{_bindir}/syz-executor
%{_bindir}/syz-fuzzer
%{_bindir}/syz-manager
%{_bindir}/syz-mutate
%{_bindir}/syz-prog2c
%{_bindir}/syz-repro
%{_bindir}/syz-stress
%{_bindir}/syz-upgrade

%changelog
* Mon Jun 20 2016 jslaby@suse.com
- Update to version 0.0+git.20160615:
  * Use readelf to obtain the upper 32 bits of addresses returned by kcov.
  * Update README.md
  * sys: support getsockopt for sctp
  * sys: support kcm and netrom
  * sys: update generated files
  * stress: fix "assignment to entry in nil map" panic
* Wed Jun  8 2016 mpluskal@suse.com
- Update to version 0.0+git.20160606:
  * Makefile: Split generate: target
  * sysgen: Cope with non-inline kernel build
  * Document how to add new system calls
  * Add debug logging to sysgen/ code
  * sys: add removed defines to fix generate in linux-next
  * Update README.md
  * stress: print program and output on more types of bugs
  * added note for email based subsciption for the mailinglist
  * Use readelf to obtain the upper 32 bits of addresses returned by kcov.
  * Update README.md
* Fri May 13 2016 mpluskal@suse.com
- Exclude building to architectures which have native go compiler
* Fri May 13 2016 jslaby@suse.com
- update to 0.0+git.20160503:
  * use readelf to obtain the upper 32 bits of addresses returned by kcov.
  * added note for email based subsciption for the mailinglist
  * stress: print program and output on more types of bugs
  * update README.md
* Thu Mar 24 2016 jslaby@suse.com
- update to 20160315
  * sys: add removed defines to fix generate in linux-next
  * Add debug logging to sysgen/ code
  * Document how to add new system calls
  * sysgen: Cope with non-inline kernel build
* Fri Mar 11 2016 jslaby@suse.com
- update to 20160310
  * Update README.md
  * executor: prevent test processes from ptracing parent processes
  * executor: ignore NOFILE errors during cleanup
  * executor: ignore the case when test process kills loop process
  * executor: make loop killing non-fatal
  * fuzzer: improve kmemleak logic
  * ipc: increase default response timeout
  * manager: dump machine state on hangs
  * manager: don't save crashers during shutdown
  * vm/qemu: strip ssh warnings
  * sys: add missing include
* Thu Mar  3 2016 jslaby@suse.com
- update to 20160219
  * config: fix calculation of enabled syscalls
  * csource: use dynamic libraries if static are not supported
  * manager: don't confuse users with zero coverage
  * properly cleanup on ctrl+C
  * Update README for dropprivs, troubleshooting
  * More logging from syz-fuzzer
  * Pass through -v <N> option from syz-manager to syz-fuzzer
  * Distinguish between no data and no symbols
- drop no-static.patch
* Thu Feb 18 2016 jslaby@suse.com
- update to 20160216
- add no-static.patch
* Tue Feb 16 2016 jslaby@suse.com
- update to 20160215
- remove allow-empty-kernel.patch: it's upstream
* Thu Feb 11 2016 jslaby@suse.com
- change require gcc6 to recommends
* Wed Feb 10 2016 jslaby@suse.com
- make and install all tools
- add: allow-empty-kernel.patch
* Tue Feb  9 2016 jslaby@suse.com
- update to 20160207
* Tue Feb  2 2016 jslaby@suse.com
- update to 20160128
  * more syscalls and devices tested
- require gcc6
* Tue Jan 26 2016 jslaby@suse.com
- update to 20160125
- remove build-flags.patch: not needed anymore
* Tue Dec  1 2015 jslaby@suse.com
- update to 20151129
- add example.cfg and structure.png
* Fri Nov 27 2015 jslaby@suse.com
- update to 20151126
* Wed Nov 11 2015 jslaby@suse.com
- initial package (20151109)
